import java.util.logging.Level;

public aspect Tracer advises TraceInsert {
	after(TraceInsert t){
		trace(t.logLevel, t.bin, t.ln, t.position);
	}
	
	private void trace(Level l, BottomNode bin, LeafNode ln, long position) {
		System.out.println("trace(" + l + ", " + bin + ", " + ln + ", " + position + ")");
	}
}
