package aj;
import orig.IN;

aspect MemoryBudget {
	pointcut monitorOverheadSizeChanges() :
		execution(void IN.setLsn(int,long)) ||
		call(void IN.shiftEntriesRight(int)) || 
		execution(void IN.hookr_deleteEntryInternal(int));

	void around(IN in) :  monitorOverheadSizeChanges() && this(in){
		int oldSize = in.computeLsnOverhead();// MB
		proceed(in);
		in.changeMemorySize(in.computeLsnOverhead() - oldSize);// MB
	}
}